View Javadoc

    1   /*
    2    *  Licensed to the Apache Software Foundation (ASF) under one
    3    *  or more contributor license agreements.  See the NOTICE file
    4    *  distributed with this work for additional information
    5    *  regarding copyright ownership.  The ASF licenses this file
    6    *  to you under the Apache License, Version 2.0 (the
    7    *  "License"); you may not use this file except in compliance
    8    *  with the License.  You may obtain a copy of the License at
    9    *
    10   *    http://www.apache.org/licenses/LICENSE-2.0
    11   *
    12   *  Unless required by applicable law or agreed to in writing,
    13   *  software distributed under the License is distributed on an
    14   *  "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    15   *  KIND, either express or implied.  See the License for the
    16   *  specific language governing permissions and limitations
    17   *  under the License.
    18   *
    19   */
    20  package org.apache.mina.handler.demux;
    21
    22  import org.apache.mina.core.session.IoSession;
    23
    24  /**
    25   * A handler interface that {@link DemuxingIoHandler} forwards
    26   * <tt>messageReceived</tt> or <tt>messageSent</tt> events to.  You have to
    27   * register your handler with the type of the message you want to get notified
    28   * using {@link DemuxingIoHandler#addReceivedMessageHandler(Class, MessageHandler)}
    29   * or {@link DemuxingIoHandler#addSentMessageHandler(Class, MessageHandler)}.
    30   *
    31   * @author <a href="http://mina.apache.org">Apache MINA Project</a>
    32   */
    33  public interface MessageHandler<E> {
    34      /**
    35       * A {@link MessageHandler} that does nothing.  This is useful when
    36       * you want to ignore a message of a specific type silently.
    37       */
    38      static MessageHandler<Object> NOOP = new MessageHandler<Object>() {
    39          public void handleMessage(IoSession session, Object message) {
    40              // Do nothing
    41          }
    42      };
    43
    44      /**
    45       * Invoked when the specific type of message is received from or sent to
    46       * the specified <code>session</code>.
    47       *
    48       * @param session the associated {@link IoSession}
    49       * @param message the message to decode. Its type is set by the implementation
    50       * @throws Exception if there is an error during the message processing
    51       */
    52      void handleMessage(IoSession session, E message) throws Exception;
    53  }